LICENSE = "BSD"
LIC_FILES_CHKSUM = "file://dhcpcd.c;beginline=6;endline=26;md5=239979d4ee04ad1437286ca7cbab34ff"

SRC_URI = "http://roy.marples.name/downloads/dhcpcd/dhcpcd-${PV}.tar.xz \
		file://01-dhcpcd-log \
		file://dhcpcd-6.4.2-syslog-to-stderr.patch \
		file://dhcpcd-5.2.8-initial-holdoff.patch \
		file://dhcpcd-missing-addr-segv.patch \
		file://dhcpcd-no-duid-llt.patch \
"

SRC_URI[md5sum] = "8acf2c0295f0c132a1e9f8060665b53d"
SRC_URI[sha256sum] = "5c823d607ed1d7513d16ec51c54e21657f1324899e0ba333a497682d88a8c6ee"

# We don't use dhcpcd's features that require udev so it's better to
# compile without them rather than risking it picking up libudev by
# itself in some builds but not others.
EXTRA_OECONF_append = " --without-udev"

PR = "r2.3"

FILES_${PN}-dbg += "/lib/dhcpcd/dev/.debug"

inherit autotools-brokensep

do_install_append() {
    # We don't want all of dhcpcd's hooks
    find ${D}${libexecdir}/dhcpcd-hooks -type f ! -name '20-resolv.conf' -print -exec rm -f "{}" \;

    # But we do want our debug hook
    install -m 644 ${WORKDIR}/01-dhcpcd-log ${D}${libexecdir}/dhcpcd-hooks/

    # And we'd rather create our own symlink for /var/db
    rmdir ${D}/var/db

    # We don't want dhcpcd's configuration, we will ship our own
    rm ${D}${sysconfdir}/dhcpcd.conf
}

